/***************************************************************
 * Name:      ActiveStereoMain.h
 * Purpose:   Defines Application Frame
 * Author:    Andy Barry (abarry@gmail.com)
 * Created:   2008-12-11
 * Copyright: Andy Barry ()
 * License:
 **************************************************************/

#ifndef ACTIVESTEREOMAIN_H
#define ACTIVESTEREOMAIN_H

//(*Headers(ActiveStereoFrame)
#include <wx/sizer.h>
#include <wx/menu.h>
#include <wx/textctrl.h>
#include <wx/spinctrl.h>
#include <wx/panel.h>
#include <wx/button.h>
#include <wx/frame.h>
#include <wx/statusbr.h>
//*)


#include <wx/numdlg.h>
#include <wx/ffile.h>

extern "C" {
    #include "SetConfig.h"
    #include "SetHorz.h"
}

#include "cv.h"
#include "highgui.h"

#include "Cameras.h"
#include "ScanThread.h"

class ActiveStereoFrame: public wxFrame
{
    public:

        ActiveStereoFrame(wxWindow* parent,wxWindowID id = -1);
        virtual ~ActiveStereoFrame();

    private:

        //(*Handlers(ActiveStereoFrame)
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnButGoClick(wxCommandEvent& event);
        void OnButSetConfigClick(wxCommandEvent& event);
        void OnButCaptureClick(wxCommandEvent& event);
        void OnButCalibrateClick(wxCommandEvent& event);
        //*)

        //(*Identifiers(ActiveStereoFrame)
        static const long ID_TEXTCTRL1;
        static const long ID_BUTTON2;
        static const long ID_SPINCTRL1;
        static const long ID_BUTTON1;
        static const long ID_BUTTON4;
        static const long ID_BUTTON3;
        static const long ID_PANEL1;
        static const long idMenuQuit;
        static const long idMenuAbout;
        static const long ID_STATUSBAR1;
        //*)

        //(*Declarations(ActiveStereoFrame)
        wxButton* butSetConfig;
        wxButton* butCapture;
        wxPanel* Panel1;
        wxTextCtrl* txtLog;
        wxButton* butCalibrate;
        wxStatusBar* StatusBar1;
        wxSpinCtrl* spinLaser;
        wxButton* butGo;
        //*)

		// OpenCV stuff
		void UpdateImage(wxCommandEvent &event);
		void DisplayText(wxCommandEvent &event);
		void WaitForLaser(wxCommandEvent &event);
		void CalibrateEvent(wxCommandEvent &event);
		int GetCalibrateDistance(int lastDistance);
		void MoveCalibrateObject(wxCommandEvent &event);

		int calibrateDistance;
		wxString calString, calString2;
		double statMax, statMin, averageSum;
		int averageNum;

		Cameras *cam;

        DECLARE_EVENT_TABLE()
};

#endif // ACTIVESTEREOMAIN_H
