#ifndef CAMERAS_H
#define CAMERAS_H

#include <wx/wx.h>

#ifndef OPENCV_INCLUDES
#define OPENCV_INCLUDES
#include "cv.h"
#include "highgui.h"


#endif // OPENCV_INCLUDES

#include "ScanThread.h"

#define NUMBER_OF_CAMERAS 1
#define CAMERA_MAX_X 320
#define CAMERA_MAX_Y 240
#define CAMERA_ZOOM 1.4  // CAMERA_ZOOM typically 240% (2.4)


class Cameras
{
	public:
		Cameras(wxTextCtrl *pMemo, wxFrame *windowIn);
		virtual ~Cameras();
		void InitializeCamera();
		void Play();
		void Pause();
		void Stop();
		IplImage *FrameGrab();
		IplImage *GetLastFrame() { return m_LastFrame; }
		void SaveSingleFrame();
		wxString GetLastCapturedFrameFilename();
		void SetCalibrate(bool x) { calibrate = x; }


	private:
		wxFrame *window;
		wxTextCtrl *m_pMemo;
		CvCapture * m_MyCapture;
		IplImage *m_LastFrame;	// contains the last frame captured
		wxString m_filename, m_CamSpacer, m_fileformat, m_FilenameIndex, m_LastCapturedFrameFilename;
		int m_NumberOfCapturedFrames, m_FrameHeight, m_FrameWidth, m_FrameRate;
		bool m_CamPaused, m_CamPlaying, m_CamStopped;
		bool CaptureExists();
		bool calibrate;



};

#endif // CAMERAS_H
